![SuperMarquee](./res/github/SuperMarqueeLogoWhiteBg.png)

![SupportedFrameworkIcons](./res/github/sp-supported-frameworks.jpg)

[![npm](https://img.shields.io/npm/dt/sp-supermarquee.svg)](https://npmjs.com/package/sp-supermarquee)
[![npm](https://img.shields.io/npm/dm/sp-supermarquee.svg)](https://npmjs.com/package/sp-supermarquee)
[![jsDelivr Hits](https://data.jsdelivr.com/v1/package/npm/sp-supermarquee/badge?style=rounded)](https://www.jsdelivr.com/package/npm/sp-supermarquee)

## About

**SuperMarquee** is the super smooth marquee web component for your web applications.

It covers all features for marquee usages, like horizontal- and vertical scrolling, different scroll speeds, custom styling etc.

In addition, SuperMarquee comes with features which no other solution have. This includes 3D hardware acceleration, inbuilt 3D transformation functionalities and the unique ping-pong mode.

Needless to say that SuperMarquee supports all your favourite frontend frameworks.

## Showcase

Get some inspiration of what is possible with the following showcase demos.

- [Newsticker](https://superplug.in/supermarquee/showcase/breakingnews)
- [eCommere](https://superplug.in/supermarquee/showcase/ecommerce)
- [3D Hero](https://superplug.in/supermarquee/showcase/starwars)
- [MarqueeWall (codepen.io)](https://codepen.io/benny00100/pen/podybRG)
- [MarqueeWiggle (codepen.io)](https://codepen.io/benny00100/pen/JjObvZK)

🚀 [Try out the new Visual Editor](https://www.superplug.in/supermarquee/visual-designer)

## Features

The most popular features of SuperMarquee:

&nbsp;&nbsp;✓&nbsp; Fully Responsive. Perfect for every resolution <br>
&nbsp;&nbsp;✓&nbsp; Easily customizable via CSS <br>
&nbsp;&nbsp;✓&nbsp; Zero dependencies <br>
&nbsp;&nbsp;✓&nbsp; Lightweight, simple yet powerful <br>
&nbsp;&nbsp;✓&nbsp; Hardware accelerated for high performance <br>
&nbsp;&nbsp;✓&nbsp; Extremely flexible. Endless possibilities <br>
&nbsp;&nbsp;✓&nbsp; Works on every modern device <br>
&nbsp;&nbsp;✓&nbsp; Supports 3D transformations <br>
&nbsp;&nbsp;✓&nbsp; Works with every major frontend framework <br>
&nbsp;&nbsp;✓&nbsp; Visual editor and code generator<br>
&nbsp;&nbsp;✓&nbsp; RSS feed support <br>

## Examples

List of single feature examples

- [Horizontal Scrolling](https://superplug.in/supermarquee/demo/1)
- [Vertical Scrolling](https://superplug.in/supermarquee/demo/2)
- [Ping Pong](https://superplug.in/supermarquee/demo/3)
- [Perspective X axis](https://superplug.in/supermarquee/demo/4)
- [Perspective dynamic](https://superplug.in/supermarquee/demo/5)
- [Styling](https://superplug.in/supermarquee/demo/6)
- [Dynamic Scroll Speed](https://superplug.in/supermarquee/demo/7)
- [Mixed Content](https://superplug.in/supermarquee/demo/8)
- [Position](https://superplug.in/supermarquee/demo/9)
- [Live Updates](https://superplug.in/supermarquee/demo/10)
- [Performance](https://superplug.in/supermarquee/demo/11)
- [Right-To-Left](https://superplug.in/supermarquee/demo/12)

## Documentation

- [Getting Started with Javascript](https://superplug.in/supermarquee/docs#start-javascript)
- [Getting Started with jQuery](https://superplug.in/supermarquee/docs#start-jquery)
- [Getting Started with Web Component](https://superplug.in/supermarquee/docs#start-webcomponent)
- [Getting Started with Angular](https://superplug.in/supermarquee/docs#start-angular)
- [Getting Started with React](https://superplug.in/supermarquee/docs#start-react)
- [Getting Started with Svelte](https://superplug.in/supermarquee/docs#start-svelte)
- [Getting Started with Vue](https://superplug.in/supermarquee/docs#start-vue)
- [API Reference](https://superplug.in/supermarquee/docs#instantiation)
- [Changelog](https://superplug.in/supermarquee/docs#changelog)
- [Examples](https://superplug.in/supermarquee#demos)

## Get Started
### Install with npm

Run the following command in your terminal
```
npm install sp-supermarquee
```

You can also load the bundle directly from [jsDelivr](https://www.jsdelivr.com/package/npm/sp-supermarquee).

### Create a placeholder

Create an HTML placeholder

```html
<div id="supermarquee"></div>
```

### Import SuperMarquee
```js
import SuperMarquee from "sp-supermarquee";
```

### Initialize 

Now turn your placeholder into a SuperMarquee instance and let the magic begin.
```js

const sm = new SuperMarquee( 
  document.getElementById('example'), {
  content : "SuperMarquee by SuperPlug.in is Super!!!"
});
```

Refer to the [official documentation](https://superplug.in/supermarquee/docs) for more details.

## Support

We provide support for developers working with commercial version by email. Please write an email to [support@superplug.in](mailto://support@superplug.in) _(please include your license key for verification)_.

If you use a non-commercial version then please ask your tagged question on [StackOverflow](https://stackoverflow.com/questions/tagged/supermarquee).

## License

SuperMarquee is a commercial software with two licenses available:

- Free for non-commercial purposes such as teaching, academic research, and evaluation. [Read it here](https://superplug.in/supermarquee#pricing).
- Commercial license with support and maintenance included. See [pricing plans](https://superplug.in/supermarquee#pricing).
